# -*- coding: utf-8 -*-
#jptools/harness2.py
#A part of NonVisual Desktop Access (NVDA)
#This file is covered by the GNU General Public License.
#See the file COPYING for more details.
#Copyright (C) 2012 Masataka.Shinke, Takuya Nishimoto
#テキスト解析とマスあけのテスト

import sys
sys.path.append(r'..\source\synthDrivers\jtalk')

import translator2
import os

def __print(s):
	print s.encode('utf-8', 'ignore')

def separate(s):
	return translator2.japanese_braille_separate(s, __print)

jtalk_dir = os.path.join(os.getcwdu(), '..', 'source', 'synthDrivers', 'jtalk')
translator2.initialize(jtalk_dir, __print)

from harness import tests
outfile = '__h2output.txt'

if __name__ == '__main__':
	with open(outfile, 'w') as f:
		count = 0
		for t in tests:
			if t.has_key('text') and separate(t['text']) != t['input']:
				count+=1 
				f.write(t['text'].encode('utf-8') + "\n")
				f.write(separate(t['text']).encode('utf-8') + "\n")
				f.write(t['input'].encode('utf-8') + "\n")
				if 'comment' in t:
					f.write(t['comment'].encode('utf-8') + "\n")
				f.write("\n")
		print '%d error(s). see %s' % (count, outfile)
