/*
#A part of NonVisual Desktop Access (NVDA)
#Copyright (C) 2010-2012 Takuya Nishimoto, Masataka Shinke (nvdajp)
#This file is covered by the GNU General Public License.
#See the file COPYING for more details.
# nvdajpime/debugout.h
# nvdajpimeRPC/debugout.h
# nvdajpimeLoader/debugout.h
*/

#ifndef DEBUGOUT_H
#define DEBUGOUT_H

using namespace std;

inline void DebugOut(const WCHAR *s)
{
  if (DEBUGOUT && s)
    OutputDebugString(s);
}

inline void DebugOut(const WCHAR *s, const WCHAR *t)
{
  if (DEBUGOUT) {
    wstringstream stream;
    if (s) {
      stream << s;
    }
    if (t) {
      stream << t;
    }
    OutputDebugString(stream.str().c_str());
  }
}

inline void DebugOut(const WCHAR *s, LONG t)
{
  if (DEBUGOUT) {
    wstringstream stream;
    if (s) {
      stream << s;
    }
    stream << t;
    OutputDebugString(stream.str().c_str());
  }
}

inline void DebugOutLastError()
{
  if (DEBUGOUT) {
    WCHAR *lpMsgBuf;
    FormatMessage(
		  FORMAT_MESSAGE_ALLOCATE_BUFFER |
		  FORMAT_MESSAGE_FROM_SYSTEM |
		  FORMAT_MESSAGE_IGNORE_INSERTS,
		  NULL,
		  GetLastError(),
		  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		  (LPTSTR) &lpMsgBuf,
		  0,
		  NULL
		  );
    DebugOut(lpMsgBuf);
  }
}

#endif
