﻿/*
#A part of NonVisual Desktop Access (NVDA)
#Copyright (C) 2010-2012 Masataka Shinke, Takuya Nishimoto (nvdajp)
#This file is covered by the GNU General Public License.
#See the file COPYING for more details.
#
# nvdajpimeRPC/dllmain.cpp
*/

#include "nvdajpime.h"
#include "tls.h"
#include "tsf.h"
#include "debugout.h"

BOOL Process_Attach(HMODULE hModule)
{
	g_hModule = hModule;

    g_SharedMemory.BaseInit();
    if (!g_SharedMemory.Start())
        return FALSE;

    if (!TLS::Initialize())
        return FALSE;

    return TRUE;
}

void Process_Detach(HMODULE hModule)
{
	g_hModule = NULL;
}

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
        //DebugOut(L"RPC: DLL_PROCESS_ATTACH");
		if (!Process_Attach(hModule))
		{
			Process_Detach(hModule);
			return FALSE;
		}
		break;
	case DLL_THREAD_ATTACH:
        //DebugOut(L"RPC: DLL_THREAD_ATTACH");
		break;
	case DLL_THREAD_DETACH:
        //DebugOut(L"RPC: DLL_THREAD_DETACH");
        TLS::DestroyTLS();
		break;
	case DLL_PROCESS_DETACH:
        //DebugOut(L"RPC: DLL_PROCESS_DETACH");
        TLS::DestroyTLS();
		Process_Detach(hModule);
		break;
	}
	return TRUE;
}

