﻿/*
#A part of NonVisual Desktop Access (NVDA)
#Copyright (C) 2010-2012 Masataka Shinke, Takuya Nishimoto (nvdajp)
#This file is covered by the GNU General Public License.
#See the file COPYING for more details.
#
# nvdajpimeRPC/tls.cpp
*/

#include "nvdajpime.h"
#include "tls.h"
#include "tsf.h"
#include "debugout.h"

// static
BOOL TLS::InternalDestroyTLS()
{
    if (dwTLSIndex == TLS_OUT_OF_INDEXES)
        return FALSE;

    TLS *ptls = (TLS *)TlsGetValue(dwTLSIndex);
    if (ptls != NULL)
    {
        if (ptls->_pReadCompTSF)
        {
            ptls->_pReadCompTSF->_InitTextEditSink(NULL);
            ptls->_pReadCompTSF->_UninitThreadMgrSink();
            ptls->_pReadCompTSF->Release();
            ptls->_pReadCompTSF = NULL;
            DebugOut(2, L"RPC: TLS::InternalDestroyTLS() _pReadCompTSF released.");
        }

        LocalFree(ptls);
        TlsSetValue(dwTLSIndex, NULL);
        return TRUE;
    }
    return FALSE;
}
