# source/NVDAObjects/IAccessible/nvdajpime.py
# -*- coding: utf-8 -*-
#A part of NonVisual Desktop Access (NVDA)
#Copyright (C) 2011-2012 Takuya Nishimoto, Masataka Shinke (nvdajp)
#This file is covered by the GNU General Public License.
#See the file COPYING for more details.

import controlTypes
import api
import ui
from . import IAccessible
import tones
from logHandler import log
import config
from nvdajp_keyEvents import reportCandidate

# see Developer Guide 3.10. 'Events'
# see IAccessibleHandler.py processShowWinEvent() for event_show()

def findSelectedObject(obj):
	if controlTypes.STATE_SELECTED in obj.states:
		return obj
	for c in obj.children:
		ret = findSelectedObject(c)
		if ret:
			return ret
	return None

class IMECandidateUI(IAccessible):

	def event_show(self):
		if not config.conf["keyboard"]["nvdajpEnableKeyEvents"]: return
		s = "devinfo \n%s\n" % "\n".join(self.devInfo)
		c = findSelectedObject(self)
		if c:
			reportCandidate(c.name, None, True)
			s += "child (%s)(%s)(%s)(%s)\n" % (c.name, c.value, str(c.role), str(c.states))
		s += "\n"
		log.debug(s)

class IMECandidateItem(IAccessible):

	def event_stateChange(self):
		if not config.conf["keyboard"]["nvdajpEnableKeyEvents"]: return
		name = self.name
		accid = self.IAccessibleChildID
		log.debug("name %s accid %d" % (name, accid))
		#log.info("name %s\n%s\n" % (name, "\n".join(self.devInfo)))
		if self.windowClassName == 'MSCandUIWindow_Candidate':
			reportCandidate(name, accid - 2, True)
		else:
			reportCandidate(name, accid, True)


